#pragma once
#ifndef PARSODUS_LRTABLES_LR1ITEM_H_OEUCDMZL
#define PARSODUS_LRTABLES_LR1ITEM_H_OEUCDMZL

#include "Parsodus/lrtables/LR0Item.h"

namespace pds {
namespace lr {

struct LR1Item {
    std::shared_ptr<Rule> rule;
    std::size_t dotIdx;
    std::set<std::string> lookaheads;

    bool operator<(const LR1Item& rhs) const; ///< Useful to keep it in a set/map
    bool operator==(const LR1Item& rhs) const;
};

} /* lr */ 
} /* pds */

#endif /* PARSODUS_LRTABLES_LR1ITEM_H_OEUCDMZL */
