#pragma once
#ifndef PARSODUS_PARSER_H
#define PARSODUS_PARSER_H

#include "ParsodusLexer.h"
#include "parsodusParser.h"
#include "config.h"
#include <deque>

namespace pds {

class Parser : public parsodusParser<std::unique_ptr<Config>> {
	public:
		Parser(ParsodusLexer lex);

	protected:
		Token lex() override;
        std::unique_ptr<Config> reduce_0(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_1(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_2(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_3(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_4(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_5(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_6(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_7(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_8(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_9(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_10(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_11(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_12(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_13(std::deque<Token> subparts) override;
        std::unique_ptr<Config> reduce_14(std::deque<Token> subparts) override;
		std::unique_ptr<Config> reduce_15(std::deque<Token> subparts) override;
		std::unique_ptr<Config> reduce_16(std::deque<Token> subparts) override;
		std::unique_ptr<Config> reduce_17(std::deque<Token> subparts) override;
		std::unique_ptr<Config> reduce_18(std::deque<Token> subparts) override;
		std::unique_ptr<Config> reduce_19(std::deque<Token> subparts) override;
		std::unique_ptr<Config> reduce_20(std::deque<Token> subparts) override;
		std::unique_ptr<Config> reduce_21(std::deque<Token> subparts) override;
		std::unique_ptr<Config> reduce_22(std::deque<Token> subparts) override;
		std::unique_ptr<Config> reduce_23(std::deque<Token> subparts) override;		

	private:
		ParsodusLexer m_lex;
		int m_precedenceCounter = 0;

};

}
#endif // PARSODUS_PARSER_H
