#include "ParsodusLexer.h"
#include "Parsodus/inputparser.h"
#include "Parsodus/parser.h"
#include "Parsodus/util/parserType.h"

namespace pds {

    InputParserException::InputParserException(std::string what): m_what(what) {} 
    const char* InputParserException::what() const throw() {
            return m_what.c_str();
    }
  	Config InputParser::parseInput(std::istream& is) {
        ParsodusLexer lex(is);
		Parser parser(lex);
     	return *parser.parse();   
	}
}
